;=========================================================================
; file : syscall64.inc
; 2015/08/30
; from linux-4.1.2/arch/x86/syscalls/syscall_64.tbl
;=========================================================================

%ifndef __SYSCALL64_INC
%define __SYSCALL64_INC

%assign SYS_read                   0
%assign SYS_write                  1
%assign SYS_open                   2
%assign SYS_close                  3
%assign SYS_newstat                4
%assign SYS_newfstat               5
%assign SYS_newlstat               6
%assign SYS_poll                   7
%assign SYS_lseek                  8
%assign SYS_mmap                   9
%assign SYS_mprotect               10
%assign SYS_munmap                 11
%assign SYS_brk                    12
%assign SYS_rt_sigaction           13
%assign SYS_rt_sigprocmask         14
%assign SYS_rt_sigreturn           15  ; stub
%assign SYS_ioctl                  16
%assign SYS_pread64                17
%assign SYS_pwrite64               18
%assign SYS_readv                  19
%assign SYS_writev                 20
%assign SYS_access                 21
%assign SYS_pipe                   22
%assign SYS_select                 23
%assign SYS_sched_yield            24
%assign SYS_mremap                 25
%assign SYS_msync                  26
%assign SYS_mincore                27
%assign SYS_madvise                28
%assign SYS_shmget                 29
%assign SYS_shmat                  30
%assign SYS_shmctl                 31
%assign SYS_dup                    32
%assign SYS_dup2                   33
%assign SYS_pause                  34
%assign SYS_nanosleep              35
%assign SYS_getitimer              36
%assign SYS_alarm                  37
%assign SYS_setitimer              38
%assign SYS_getpid                 39
%assign SYS_sendfile64             40
%assign SYS_socket                 41
%assign SYS_connect                42
%assign SYS_accept                 43
%assign SYS_sendto                 44
%assign SYS_recvfrom               45
%assign SYS_sendmsg                46
%assign SYS_recvmsg                47
%assign SYS_shutdown               48
%assign SYS_bind                   49
%assign SYS_listen                 50
%assign SYS_getsockname            51
%assign SYS_getpeername            52
%assign SYS_socketpair             53
%assign SYS_setsockopt             54
%assign SYS_getsockopt             55
%assign SYS_clone                  56  ; stub
%assign SYS_fork                   57  ; stub
%assign SYS_vfork                  58  ; stub
%assign SYS_execve                 59  ; stub
%assign SYS_exit                   60
%assign SYS_wait4                  61
%assign SYS_kill                   62
%assign SYS_newuname               63
%assign SYS_semget                 64
%assign SYS_semop                  65
%assign SYS_semctl                 66
%assign SYS_shmdt                  67
%assign SYS_msgget                 68
%assign SYS_msgsnd                 69
%assign SYS_msgrcv                 70
%assign SYS_msgctl                 71
%assign SYS_fcntl                  72
%assign SYS_flock                  73
%assign SYS_fsync                  74
%assign SYS_fdatasync              75
%assign SYS_truncate               76
%assign SYS_ftruncate              77
%assign SYS_getdents               78
%assign SYS_getcwd                 79
%assign SYS_chdir                  80
%assign SYS_fchdir                 81
%assign SYS_rename                 82
%assign SYS_mkdir                  83
%assign SYS_rmdir                  84
%assign SYS_creat                  85
%assign SYS_link                   86
%assign SYS_unlink                 87
%assign SYS_symlink                88
%assign SYS_readlink               89
%assign SYS_chmod                  90
%assign SYS_fchmod                 91
%assign SYS_chown                  92
%assign SYS_fchown                 93
%assign SYS_lchown                 94
%assign SYS_umask                  95
%assign SYS_gettimeofday           96
%assign SYS_getrlimit              97
%assign SYS_getrusage              98
%assign SYS_sysinfo                99
%assign SYS_times                  100
%assign SYS_ptrace                 101
%assign SYS_getuid                 102
%assign SYS_syslog                 103
%assign SYS_getgid                 104
%assign SYS_setuid                 105
%assign SYS_setgid                 106
%assign SYS_geteuid                107
%assign SYS_getegid                108
%assign SYS_setpgid                109
%assign SYS_getppid                110
%assign SYS_getpgrp                111
%assign SYS_setsid                 112
%assign SYS_setreuid               113
%assign SYS_setregid               114
%assign SYS_getgroups              115
%assign SYS_setgroups              116
%assign SYS_setresuid              117
%assign SYS_getresuid              118
%assign SYS_setresgid              119
%assign SYS_getresgid              120
%assign SYS_getpgid                121
%assign SYS_setfsuid               122
%assign SYS_setfsgid               123
%assign SYS_getsid                 124
%assign SYS_capget                 125
%assign SYS_capset                 126
%assign SYS_rt_sigpending          127
%assign SYS_rt_sigtimedwait        128
%assign SYS_rt_sigqueueinfo        129
%assign SYS_rt_sigsuspend          130
%assign SYS_sigaltstack            131
%assign SYS_utime                  132
%assign SYS_mknod                  133
;
%assign SYS_personality            135
%assign SYS_ustat                  136
%assign SYS_statfs                 137
%assign SYS_fstatfs                138
%assign SYS_sysfs                  139
%assign SYS_getpriority            140
%assign SYS_setpriority            141
%assign SYS_sched_setparam         142
%assign SYS_sched_getparam         143
%assign SYS_sched_setscheduler     144
%assign SYS_sched_getscheduler     145
%assign SYS_sched_get_priority_max 146
%assign SYS_sched_get_priority_min 147
%assign SYS_sched_rr_get_interval  148
%assign SYS_mlock                  149
%assign SYS_munlock                150
%assign SYS_mlockall               151
%assign SYS_munlockall             152
%assign SYS_vhangup                153
%assign SYS_modify_ldt             154
%assign SYS_pivot_root             155
%assign SYS_sysctl                 156
%assign SYS_prctl                  157
%assign SYS_arch_prctl             158
%assign SYS_adjtimex               159
%assign SYS_setrlimit              160
%assign SYS_chroot                 161
%assign SYS_sync                   162
%assign SYS_acct                   163
%assign SYS_settimeofday           164
%assign SYS_mount                  165
%assign SYS_umount                 166
%assign SYS_swapon                 167
%assign SYS_swapoff                168
%assign SYS_reboot                 169
%assign SYS_sethostname            170
%assign SYS_setdomainname          171
%assign SYS_iopl                   172
%assign SYS_ioperm                 173
;
%assign SYS_init_module            175
%assign SYS_delete_module          176
;
;
%assign SYS_quotactl               179
;
;
;
;
;
;
%assign SYS_gettid                 186
%assign SYS_readahead              187
%assign SYS_setxattr               188
%assign SYS_lsetxattr              189
%assign SYS_fsetxattr              190
%assign SYS_getxattr               191
%assign SYS_lgetxattr              192
%assign SYS_fgetxattr              193
%assign SYS_listxattr              194
%assign SYS_llistxattr             195
%assign SYS_flistxattr             196
%assign SYS_removexattr            197
%assign SYS_lremovexattr           198
%assign SYS_fremovexattr           199
%assign SYS_tkill                  200
%assign SYS_time                   201
%assign SYS_futex                  202
%assign SYS_sched_setaffinity      203
%assign SYS_sched_getaffinity      204
;
%assign SYS_io_setup               206
%assign SYS_io_destroy             207
%assign SYS_io_getevents           208
%assign SYS_io_submit              209
%assign SYS_io_cancel              210
;
%assign SYS_lookup_dcookie         212
%assign SYS_epoll_create           213
;
;
%assign SYS_remap_file_pages       216
%assign SYS_getdents64             217
%assign SYS_set_tid_address        218
%assign SYS_restart_syscall        219
%assign SYS_semtimedop             220
%assign SYS_fadvise64              221
%assign SYS_timer_create           222
%assign SYS_timer_settime          223
%assign SYS_timer_gettime          224
%assign SYS_timer_getoverrun       225
%assign SYS_timer_delete           226
%assign SYS_clock_settime          227
%assign SYS_clock_gettime          228
%assign SYS_clock_getres           229
%assign SYS_clock_nanosleep        230
%assign SYS_exit_group             231
%assign SYS_epoll_wait             232
%assign SYS_epoll_ctl              233
%assign SYS_tgkill                 234
%assign SYS_utimes                 235
;
%assign SYS_mbind                  237
%assign SYS_set_mempolicy          238
%assign SYS_get_mempolicy          239
%assign SYS_mq_open                240
%assign SYS_mq_unlink              241
%assign SYS_mq_timedsend           242
%assign SYS_mq_timedreceive        243
%assign SYS_mq_notify              244
%assign SYS_mq_getsetattr          245
%assign SYS_kexec_load             246
%assign SYS_waitid                 247
%assign SYS_add_key                248
%assign SYS_request_key            249
%assign SYS_keyctl                 250
%assign SYS_ioprio_set             251
%assign SYS_ioprio_get             252
%assign SYS_inotify_init           253
%assign SYS_inotify_add_watch      254
%assign SYS_inotify_rm_watch       255
%assign SYS_migrate_pages          256
%assign SYS_openat                 257
%assign SYS_mkdirat                258
%assign SYS_mknodat                259
%assign SYS_fchownat               260
%assign SYS_futimesat              261
%assign SYS_newfstatat             262
%assign SYS_unlinkat               263
%assign SYS_renameat               264
%assign SYS_linkat                 265
%assign SYS_symlinkat              266
%assign SYS_readlinkat             267
%assign SYS_fchmodat               268
%assign SYS_faccessat              269
%assign SYS_pselect6               270
%assign SYS_ppoll                  271
%assign SYS_unshare                272
%assign SYS_set_robust_list        273
%assign SYS_get_robust_list        274
%assign SYS_splice                 275
%assign SYS_tee                    276
%assign SYS_sync_file_range        277
%assign SYS_vmsplice               278
%assign SYS_move_pages             279
%assign SYS_utimensat              280
%assign SYS_epoll_pwait            281
%assign SYS_signalfd               282
%assign SYS_timerfd_create         283
%assign SYS_eventfd                284
%assign SYS_fallocate              285
%assign SYS_timerfd_settime        286
%assign SYS_timerfd_gettime        287
%assign SYS_accept4                288
%assign SYS_signalfd4              289
%assign SYS_eventfd2               290
%assign SYS_epoll_create1          291
%assign SYS_dup3                   292
%assign SYS_pipe2                  293
%assign SYS_inotify_init1          294
%assign SYS_preadv                 295
%assign SYS_pwritev                296
%assign SYS_rt_tgsigqueueinfo      297
%assign SYS_perf_event_open        298
%assign SYS_recvmmsg               299
%assign SYS_fanotify_init          300
%assign SYS_fanotify_mark          301
%assign SYS_prlimit64              302
%assign SYS_name_to_handle_at      303
%assign SYS_open_by_handle_at      304
%assign SYS_clock_adjtime          305
%assign SYS_syncfs                 306
%assign SYS_sendmmsg               307
%assign SYS_setns                  308
%assign SYS_getcpu                 309
%assign SYS_process_vm_readv       310
%assign SYS_process_vm_writev      311
%assign SYS_kcmp                   312
%assign SYS_finit_module           313
%assign SYS_sched_setattr          314
%assign SYS_sched_getattr          315
%assign SYS_renameat2              316
%assign SYS_seccomp                317
%assign SYS_getrandom              318
%assign SYS_memfd_create           319
%assign SYS_kexec_file_load        320
%assign SYS_bpf                    321
%assign SYS_execveat               322  ; stub

%endif
